/* EOAccessLargeArrayFaultHandler.m created by toon on Thu 17-Feb-2000 */

#import "EOAccessLargeArrayFaultHandler.h"

@implementation EOAccessLargeArrayFaultHandler

- (void)dealloc;
{
    [additions release];
    [removals release];
    [super dealloc];
}

- (void)completeInitializationOfObject:(NSMutableArray *)array;
{
    NSMutableSet *set;

    // Have to munge around with sets here (or do something similar), because if you make additions or removals, then save, and finally fetch the array fault, the array will already have some or all of the changes applied to it.

    [super completeInitializationOfObject:array];
    if (additions || removals) {
        set = [[NSMutableSet alloc] initWithArray:array];
        if (additions)
            [set unionSet:additions];
        if (removals)
            [set minusSet:removals];
        [array removeAllObjects];
        [array addObjectsFromArray:[set allObjects]];
        [set release];
    }
}

- (void)addObject:anObject;
{
    if ([removals member:anObject])
        [removals removeObject:anObject];
    else {
        if (!additions)
            additions = [[NSMutableSet alloc] init];
        [additions addObject:anObject];
    }
}

- (void)removeObject:anObject;
{
    if ([additions member:anObject])
        [additions removeObject:anObject];
    else {
        if (!removals)
            removals = [[NSMutableSet alloc] init];
        [removals addObject:anObject];
    }
}

@end
